//
// Copyright (C) 2008 Jonathan Moore Liles
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

// generated by Fast Light User Interface Designer (fluid) version 1.0300

#include "New_Project_Dialog.H"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <FL/Fl_File_Chooser.H>

void New_Project_Dialog::cb_Browse_i(Fl_Button*, void*) {
  _directory->value( fl_dir_chooser( "Directory for new project", NULL, 0 ) );
}
void New_Project_Dialog::cb_Browse(Fl_Button* o, void* v) {
  ((New_Project_Dialog*)(o->parent()->user_data()))->cb_Browse_i(o,v);
}

void New_Project_Dialog::cb_Create_i(Fl_Return_Button*, void*) {
  if ( strlen( _directory->value() ) && strlen( _name->value() ) )
{
	char pat[1024];
	
	snprintf( pat, sizeof( pat ), "%s/%s", _directory->value(), _name->value() );
	
	path = strdup( pat );
	
        _default_path = _directory->value() ? strdup( _directory->value() ) : 0;

	//if ( ! Project::create( pat, _template->text( _template->value() ) ) )
	//	fl_alert( "Error creating project!" );

	_window->hide();
};
}
void New_Project_Dialog::cb_Create(Fl_Return_Button* o, void* v) {
  ((New_Project_Dialog*)(o->parent()->user_data()))->cb_Create_i(o,v);
}

void New_Project_Dialog::cb__directory_i(Fl_File_Input* o, void*) {
  if ( ! fl_filename_isdir( o->value() ) )
{
	fl_alert( "Must be a directory" );
	o->value( "" );
	return;
}

// write_line( user_config_dir, "default_path", o->value() );
}
void New_Project_Dialog::cb__directory(Fl_File_Input* o, void* v) {
  ((New_Project_Dialog*)(o->parent()->user_data()))->cb__directory_i(o,v);
}

Fl_Menu_Item New_Project_Dialog::menu__template[] = {
 {"Default", 0,  0, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

New_Project_Dialog::New_Project_Dialog() {
  _default_path = 0;
  path = 0;
  make_window();
}

void New_Project_Dialog::run() {
  _directory->value( _default_path );
  
  _window->show();
  
  while ( _window->shown() )
  	Fl::wait();
}

Fl_Double_Window* New_Project_Dialog::make_window() {
  { _window = new Fl_Double_Window(550, 195, "New Project");
    _window->user_data((void*)(this));
    { _name = new Fl_File_Input(75, 140, 375, 35, "Named:");
    } // Fl_File_Input* _name
    { Fl_Button* o = new Fl_Button(455, 100, 80, 35, "Browse");
      o->callback((Fl_Callback*)cb_Browse);
    } // Fl_Button* o
    { Fl_Return_Button* o = new Fl_Return_Button(455, 140, 80, 35, "Create");
      o->callback((Fl_Callback*)cb_Create);
    } // Fl_Return_Button* o
    { Fl_File_Input* o = _directory = new Fl_File_Input(75, 100, 375, 35, "Where:");
      _directory->callback((Fl_Callback*)cb__directory);
      char *v = NULL;
      // read_line( user_config_dir, "default_path", &v );
      o->value( v );
    } // Fl_File_Input* _directory
    { Fl_Box* o = new Fl_Box(15, 8, 520, 33, "New Project");
      o->box(FL_RSHADOW_BOX);
      o->color((Fl_Color)133);
      o->labelsize(20);
      o->labelcolor(FL_GRAY0);
    } // Fl_Box* o
    { _template = new Fl_Choice(310, 60, 225, 25, "Template:");
      _template->down_box(FL_BORDER_BOX);
      _template->menu(menu__template);
    } // Fl_Choice* _template
    _window->set_modal();
    _window->xclass("Non_DAW");
    _window->end();
  } // Fl_Double_Window* _window
  return _window;
}

void New_Project_Dialog::templates( const char **templates ) {
  for ( const char **s = templates; *s; ++s )
  	_template->add( *s );
}

void New_Project_Dialog::default_path( char *s ) {
  _default_path = s;
}

char * New_Project_Dialog::default_path() {
  return _default_path;
}

const char * New_Project_Dialog::selected_template() {
  return _template->text( _template->value() );
}

char* new_project_chooser( const char **templates, char **default_path, char **selected_template ) {
  New_Project_Dialog nsd;
  
  nsd.templates( templates );
  nsd.default_path( *default_path );
  
  nsd.run();
  
  *default_path = strdup( nsd.default_path() );
  *selected_template = strdup( nsd.selected_template() );
  
  return nsd.path;
}
